﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.5
@EndOfDesignText@
Sub Class_Globals
	Private mEventName As String 'ignore
	Private mCallBack As Object 'ignore
	Private xui As XUI
	Dim cvs As Canvas
	Private Panel1 As B4XView
	Dim x,y,radius As Int
	Dim AngleOffset  As Int
	Dim AngleRange As Int
	
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize(p As Panel,x1 As Int,y1 As Int)		
	'mEventName = EventName
	'mCallBack = Callback
	Panel1 = p
	
	cvs.Initialize(Panel1)
	radius = Panel1.Width/2-50dip
	AngleOffset = -90
	AngleRange = 360
	x = x1
	y = y1
	
End Sub

Sub drawcircle(h As Int,v As Int,rad As Int,col As Int,fill As Boolean,linewidth As Int)	
	cvs.DrawCircle(h,v,rad,col,fill,linewidth)	
End Sub

Sub DrawTicks
	Dim r1 As Int = radius - 20dip
	Dim LongTick As Int = r1 - 12dip
	Dim ShortTick As Int = r1 - 8dip
	Dim NumberOfTicks As Int
	NumberOfTicks = 360
	Dim txt As String = 0
	
	For i = 0 To NumberOfTicks Step 10
		If i = 360 Then Exit
		Dim thickness, r As Int
		Dim angle As Float = i * AngleRange / NumberOfTicks + AngleOffset
		thickness = 3dip
		Dim tr As Float = LongTick + 25dip
		
		cvs.DrawLine(x + LongTick* CosD(angle), y + LongTick * SinD(angle), x + r1 * CosD(angle), y + r1 * SinD(angle), xui.Color_white, thickness)
	
		Dim temptxt As String
		If txt = 0 Then
			temptxt = "N"
		Else If txt = 90 Then
			temptxt = "E"
		Else If txt = 180 Then
			temptxt = "S"
		Else If txt = 270 Then
			temptxt = "W"
		Else
			temptxt = txt
		End If
		'Log(angle)
		cvs.DrawTextRotated(temptxt, x + tr * CosD(angle),y + tr * SinD(angle),Typeface.DEFAULT_BOLD, 40, Colors.white, "CENTER", angle + 90)
			
		txt = txt + 10
		
	Next
		
	For i = 0 To NumberOfTicks
		If i = 360 Then Exit
		Dim thickness, r As Int
		Dim angle As Float = i * AngleRange / NumberOfTicks + AngleOffset
		thickness = 1dip
		r = ShortTick
		Dim tr As Float = r + 10dip
		cvs.DrawLine(x + r * CosD(angle), y + r * SinD(angle), x + r1 * CosD(angle), y + r1 * SinD(angle), xui.Color_white, thickness)
		
	Next
End Sub